<template>
	<div class="dailies row-padding col-padding azure-gradient lightestazure-color">
		<h3 class="hustle medium ">{{getLocale('daily_missions')}}</h3>
			
		<div class="container flex lightestazure-border">
			<div 
				v-for="(daily, index) in getCurrentDailies" 
				class="daily column-of-3 row-padding col-padding align-center"
				:class="{
					'completable lightestgreen-color' : !completedDailies[index] && getProgress(daily).percent == 100,
					completed : completedDailies[index],
				}"
			>
				<div class="inner">
					<div class="text uppercase">
						<div v-if="daily.type == 'vairus'">{{getLocale('catch')}} {{daily.objective}} Vairus</div>
						<div v-if="daily.type == 'vairus_biome'">{{getLocale('catch')}} {{daily.objective}} Vairus {{getLocale('of_category')}} {{getLocale(daily.subtype)}}</div>
						<div v-if="daily.type == 'matrix'">{{getLocale('take_part')}} {{daily.objective}} {{getLocale('matrixes')}}</div>
						<div v-if="daily.type == 'powerup'">{{getLocale('increase_level')}} {{daily.objective}} {{getLocale('times')}}</div>
						<div v-if="daily.type == 'mutation'">{{getLocale('make')}} {{daily.objective}} {{getLocale('mutations')}}</div>
					</div>
					
					<div class="progress">
						<div class="svg-wrapper">
							<svg xmlns="http://www.w3.org/2000/svg" 
								:width="svg_radius*2 + svg_width" :height="svg_radius*2 + svg_width" 
								:viewBox="'-2 -2 '+(svg_radius*2 + svg_width + 4)+' '+(svg_radius*2 + svg_width + 4)"
							>
								<defs>
									<radialGradient id="green-gradient">
										<stop offset="10%" stop-color="black" />
										<stop offset="95%" stop-color="#00FFB3" />
									</radialGradient>
									
									<radialGradient id="blue-gradient">
										<stop offset="10%" stop-color="black" />
										<stop offset="95%" stop-color="#0E2D3F" />
									</radialGradient>
									
									<filter id="box-shadow" filterUnits="userSpaceOnUse">
										<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
										<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
										<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
									</filter>
								</defs>
								
								<circle 
									v-if="!completedDailies[index]"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius" stroke-width="1" fill="transparent" 
									:stroke="(daily.objective - getProgress(daily).value <= 0)? '#02FBB1' : '#B0F0FD'"
								/>
								
								<circle 
									v-if="completedDailies[index]"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius" stroke-width="0" fill="url('#blue-gradient')"
								/>
								
								<circle 
									class="complete-button" opacity="0.5"
									v-if="!completedDailies[index] && getProgress(daily).percent == 100"
									:cx="svg_radius+(svg_width/2)" :cy="svg_radius+(svg_width/2)" 
									:r="svg_radius - 20" stroke-width="0" fill="url('#green-gradient')"
									v-on:click="completeDaily(index)"
								/>
								
								<path 
									v-if="!completedDailies[index]"
									v-for="n in daily.objective"
									filter="url(#box-shadow)"
									:filter="((daily.objective - getProgress(daily).value <= 0) || (n <= getProgress(daily).value))? 'url(#box-shadow)' : ''"
									fill="none" :stroke="(daily.objective - getProgress(daily).value <= 0)? '#02FBB1' :  (n <= getProgress(daily).value) ? '#B0F0FD' : '#3B4855'" 
									:stroke-width="svg_width" 
									:d="describeArc((dailyDegrees(daily.objective)*(n-1))+svg_width/2, (dailyDegrees(daily.objective)*n)-svg_width/2, svg_radius, svg_width)"
								></path>
							</svg>
							
							<div v-if="!completedDailies[index] && getProgress(daily).percent == 100" class="rewards-icon" :style="{ 'background-image' : 'url('+getImage('daily-reward.svg')+')' }"></div>
							<div v-if="completedDailies[index]" class="completed-icon" :style="{ 'background-image' : 'url('+getImage('daily-completed.svg')+')' }"></div>
						</div>
						
						<div v-if="!completedDailies[index] && getProgress(daily).percent != 100" class="text">
							{{daily.objective - getProgress(daily).value}}
						</div>
						
					</div>
					
					<div class="reward row-padding flex uppercase">
						<div v-if="!completedDailies[index]">
							<div>{{getLocale('reward')}}</div>
							<div class="flex h-center v-center">
								<div>{{daily.reward}}</div>
								<bytes-icon class="icon"/>
							</div>
						</div>
						<div v-else class="completed-text">
							{{getLocale('completed')}}
						</div>
					</div>
				</div>
			</div>
			
			<v-info class="expiration" color="#B3EDFF" :text="timeLeft" v-tooltip="'daily_expiration_tooltip'" />
		</div>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import Vue from 'vue';
	import VButton from '../components/VButton.vue';
	import VInfo from '../components/VInfo.vue';
	import BytesIcon from '../components/BytesIcon.vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	import seedrandom from 'seedrandom';
	
	export default {
		data: function () {
			return{
				dailies : [],
				svg_radius : 100,
				svg_width : 8,
			}
		},
		methods: {
			getProgress(daily){
				let value = 0;
				
				if(daily.type == 'vairus'){
					value = this.getVairusProgress.total;
				}
				if(daily.type == 'vairus_biome'){
					value = this.getVairusProgress[daily.subtype];
				}
				if(daily.type == 'matrix'){
					value = this.getMatrixProgress;
				}
				if(daily.type == 'powerup'){
					value = this.getPowerupProgress;
				}
				if(daily.type == 'mutation'){
					value = this.getMutationProgress;
				}
				
				value = Math.min(value, daily.objective);
				
				return {
					value : value,
					percent : (value*100)/daily.objective
				};
			},
			completeDaily(index){
				if(this.complete_daily_lock) return;
				this.$store.commit('setActionLock', 'complete_daily_lock');
			
				browser.runtime.sendMessage({
					type : 'complete_daily',
					data : { index : index }
				});
			},
			dailyDegrees(objective){
				return Math.floor(360/objective*100)/100;
			},
			createDaily(rng){
				let type_id = Math.floor(rng()*5);
				let type = '';
				let subtype = '';
				let difficulty = Math.floor(rng()*3)+1;
				let objective = 0;
				let reward = (difficulty == 1)? 1000 : (difficulty == 2) ? 2500 : 5000;
				
				switch(type_id){
					case 0:
						type = 'vairus';
						objective = (difficulty == 1)? 10 : (difficulty == 2) ? 20 : 30;
					break;
					case 1:
						type = 'vairus_biome';
						let subtype_rng = Math.floor(rng()*8);
						switch(subtype_rng){
							case 0: subtype = 'mountain'; break;
							case 1: subtype = 'ocean'; break;
							case 2: subtype = 'desert'; break;
							case 3: subtype = 'sky'; break;
							case 4: subtype = 'swamp'; break;
							case 5: subtype = 'city'; break;
							case 6: subtype = 'glacier'; break;
							case 7: subtype = 'forest'; break;
						}
						objective = (difficulty == 1)? 3 : (difficulty == 2) ? 6 : 9;
					break;
					case 2:
						type = 'matrix';
						objective = difficulty;
					break;
					case 3:
						type = 'powerup';
						objective = difficulty*5;
					break;
					case 4:
						type = 'mutation';
						objective = 1;
						reward = 3000;
					break;
				}
				
				let daily = {
					type : type,
					subtype	: subtype,
					objective : objective,
					reward : reward
				};
				return daily;
			},
		},
		computed: {
			getCurrentDailies(){
				let rng = seedrandom(this.dailies_seed);
				let dailies = [];
				
				while(dailies.length < 3){
					var daily = this.createDaily(rng);
					
					var copy = dailies.find(function(d){
						return d.type == daily.type && d.subtype == daily.subtype && d.objective == daily.objective
					});
					
					if(typeof copy == 'undefined'){
						dailies.push(daily);
					}
				}
				
				return dailies;
			},
			completedDailies(){
				let completed = [false, false, false];
				this.dailies_rewards.forEach(function(r){
					if(r.date >= this.startOfDay){
						completed[r.daily] = true;
					};
				}.bind(this));
				return completed;
			},
			startOfDay(){
				let now = new Date().getTime();
				return Math.floor((now - (now%(1000*60*60*24)))/1000);
			},
			getVairusProgress(){
				let list = this.dailies_progress.filter(function(p){
					return p.type == 'vairus' && p.date >= this.startOfDay;
				}.bind(this));
				
				let types = {
					total : list.length,
					mountain : 0, ocean : 0, desert : 0, sky : 0,
					swamp : 0, city : 0, glacier : 0, forest : 0,
				};
				
				list.forEach(function(p){
					types[p.subtype]++;
				});
				
				return types;
			},
			getMatrixProgress(){
				return this.dailies_progress.filter(function(p){
					return p.type == 'matrix' && p.date >= this.startOfDay;
				}.bind(this)).length;
			},
			getMutationProgress(){
				return this.dailies_progress.filter(function(p){
					return p.type == 'mutation' && p.date >= this.startOfDay;
				}.bind(this)).length;
			},
			getPowerupProgress(){
				return this.dailies_progress.reduce(function(value, p){
					if(p.type == 'powerup' && p.date >= this.startOfDay){
						return value+parseInt(p.subtype);
					}else{
						return value;
					}
				}.bind(this), 0);
			},
			timeLeft(){
				let end_of_day = new Date(); 
				end_of_day.setUTCHours(23, 59, 59, 999); 
				let end_timestamp = end_of_day.getTime();
				let time_left = end_timestamp-this.current_time;
				
				let h = Math.floor(time_left/3600000);
				let m = Math.floor((time_left-(h*3600000))/60000);
				let s = Math.floor(((time_left-(h*3600000))-(m*60000))/1000)
				
				return h+'h '+m+'m '+s+'s';
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			VButton, VInfo, BytesIcon
		}
	}
	
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.dailies{
		border-radius: 10px;
		padding-bottom: 40px;
		
		h3{
			margin-bottom: 10px;
		}
	
		.title{
			margin-bottom: 20px;
		}
		
		.container{
			position: relative;
			
			.daily{
				margin-left: 50px;
				position: relative;
					
				&:first-child{
					margin-left: 0;
				}
				
				.inner > .text{
					height: 40px;
				}
				
				.progress{
					position: relative;
					margin-top: 20px;
					
					.text{
						position: absolute;
						left: 0;
						top: 0;
						width: 100%;
						height: 100%;
						bottom: 0;
						text-align: center;
						line-height: 205px;
						font-size: 5rem;
					}
					
					.svg-wrapper{
						display: inline-block;
						position: relative;
						
						svg{
							display: block;
						}
						
						.complete-button{
							cursor: pointer;
						}
						
						.rewards-icon{
							position: absolute;
							width: 64px;
							height: 64px;
							top: 64px;
							left: 80px;
							background-position: center;
							background-repeat: no-repeat;
							background-size: contain;
							pointer-events: none;
						}
						.completed-icon{
							position: absolute;
							width: 64px;
							height: 64px;
							top: 50%;
							left: 50%;
							transform: translate(-50%,-50%);
							background-position: center;
							background-repeat: no-repeat;
							background-size: contain;
							pointer-events: none;
						}
					}
					
				}
				
				.reward{
					justify-content: center;
					
					.icon{
						margin-left: 5px;
						width: 20px;
						background-size: contain;
						background-repeat: no-repeat;
						background-position: center;
					}
					
					.completed-text{
						width: 100px;
					}
				}
				
			}
			
			.expiration{
				position: absolute;
				bottom: -18px;
				left: 50%;
				transform: translateX(-50%);
			}
		}
	}
	
	@media screen and (max-width: 960px) {
		.dailies .container .daily{
			margin-left: 0;
			
			.progress .svg-wrapper svg{
				width: 100%;
			}
		}
	}
	
	@media screen and (max-width: 600px) {
		.dailies .container{
			display: block;
			
			.daily{
				width: 100%;
				
				.inner > .text{
					height: auto;
				}
				
				.progress{
					margin-top: 10px;
				}
				.reward{
					padding-top: 10px;
				}
			}
		}
	}
</style>
